"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
exports.ValueGenerators = {
    any: function () { return 'anyValue'; },
    symbol: function () { return 'anyValue'; },
    array: function () { return _.times(5, exports.ValueGenerators.any); },
    bool: function () { return true; },
    func: function () { },
    number: function () { return 1337; },
    object: function () { return ({ any: exports.ValueGenerators.any() }); },
    string: function () { return 'stringval'; },
    node: function () {
        return React.createElement('span', {
            className: 'node',
            children: exports.ValueGenerators.any()
        });
    },
    element: function () {
        return React.createElement('span', {
            className: 'element',
            children: exports.ValueGenerators.any()
        });
    },
    instanceOf: function () { return new function Klazz() { }(); },
    oneOf: function (values) { return values[0]; },
    oneOfType: function (types) { return types[0].__jestSnapper__.fake(); },
    arrayOf: function (type) { return _.times(5, type.__jestSnapper__.fake); },
    objectOf: function (type) { return ({
        one: type.__jestSnapper__.fake(),
        two: type.__jestSnapper__.fake()
    }); },
    shape: function (shape) { return constructProps(shape); }
};
var warnAndExit = function (failedKey) {
    var message = [
        "jest-snapper failed to derive mock data for your propType \"" + failedKey + "\"\n",
        "This could be because",
        "  1. You defined and incorrect propType for " + failedKey,
        "  2. You forgot to initialize jest snapper with init(PropTypes) from your jest init script. (See docs)",
        "  3. You called init with a different PropTypes import package than the one you're using in the component",
        "      ex: Mixing React.PropTypes and 'prop-types' package",
        "  4. We do not yet supprt " + failedKey + " (in which case, please file an issue)\n",
        "  jest-snapper will skip this prop - possibly leading to an incorrect snapshot."
    ].join('\n');
    console.log(message);
};
// TODO: fix typings
var constructProps = function (propTypes) {
    return _(propTypes)
        .mapValues(function (value, key) {
        if (!value.__jestSnapper__) {
            warnAndExit(key);
            return;
        }
        return value.__jestSnapper__.fake();
    })
        .value();
};
exports.default = constructProps;
