"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constructProps_1 = require("./constructProps");
var _ = require("lodash");
var getInfusion = function (key, values) {
    if (!constructProps_1.ValueGenerators[key]) {
        return;
    }
    return { fake: function () { return constructProps_1.ValueGenerators[key](values); } };
};
var mutateWithSnapperObj = function (obj, key, types) {
    return Object.assign(obj, {
        __jestSnapper__: getInfusion(key, types)
    });
};
var mutatePropTypes = function (propTypes) {
    return _.forOwn(propTypes, function (value, key) {
        if (value.isRequired) {
            // primitive proptypes
            mutateWithSnapperObj(value, key);
            mutateWithSnapperObj(value.isRequired, key);
            Object.assign(propTypes, (_a = {},
                _a[key] = value,
                _a));
        }
        else {
            // complex proptypes
            var originalFn_1 = value;
            var wrappedFn = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var retValue = originalFn_1.apply(void 0, args);
                mutateWithSnapperObj.apply(void 0, [retValue, key].concat(args));
                mutateWithSnapperObj.apply(void 0, [retValue.isRequired, key].concat(args));
                return retValue;
            };
            Object.assign(propTypes, (_b = {},
                _b[key] = wrappedFn,
                _b));
        }
        var _a, _b;
    });
};
var POSSIBLE_PROPTYPES = [
    function () { return require('prop-types'); },
    function () { return require('react').PropTypes; }
];
var injectToPropTypes = function () {
    return _(POSSIBLE_PROPTYPES).each(function (requireProptypes) {
        try {
            var propTypes = requireProptypes();
            if (propTypes.__jestSnapper__) {
                return;
            }
            mutatePropTypes(propTypes);
            propTypes.__jestSnapper__ = {
                patched: true
            };
        }
        catch (e) {
            // TODO: initialize debug and log here.
        }
    });
};
exports.default = injectToPropTypes;
